#!/usr/local/bin/ruby -Ks
  # copy rrxwin.rb | rrx.rb to the ruby library path
require "fileutils"
if RUBY_PLATFORM =~ /mswin(?!ce)|mingw|cygwin|bccwin/i
  require "win32ole"
end

if defined?(WIN32OLE)
  def search_rcmd_path()
      whome = WIN32OLE.new("WScript.Shell").SpecialFolders("MyDocuments")
      whome = whome.sub(/^[A-Z]\:/i, "").gsub(/\\/, "/") + "/R"
      dir_list = ['/R', '/Program Files/R', '/Program Files (x86)/R', whome]
      file_system = WIN32OLE.new("Scripting.FileSystemObject")
      drives = file_system.Drives
      res = nil
      drives.each do |drive|
        next  unless drive.IsReady
        dl = "#{drive.DriveLetter}"
        base_dir = nil
        dir_list.each do |dd|
          w = "#{dl}:#{dd}"
          if test(?d, w)
            base_dir = w
            break
          end
        end
        next  unless base_dir
        ary = []
        Dir.glob("#{base_dir}/R-*") {|dname|
          next  unless test(?d, dname)
          fname = "#{dname}/bin/i386/Rcmd.exe"
          if test(?e, fname)
            ary << fname
          end
        }
        if ary.size > 0
          if ary.size > 1
            ary = ary.sort
          end
          res = ary[-1]
          break
        end
      end
      return res
  end
else
  def search_rcmd_path()
    return nil
  end
end

def remove_old_file(*file_list)
    ary = $:
    count = 0
    ary.each do |dir|
      next  if dir =~ /^\./
      dir = dir.gsub(/\\/, "/")
      dir = dir.sub(/\/+$/, "")
      file_list.each do |fname|
        filename = dir + "/#{fname}"
        if test(?e, filename)
          File.unlink(filename)
          puts "delete '#{filename}'"
          count += 1
        end
      end
    end
    return count
end

## main
src = []
if test(?e, "rrx.rb")
  src << "rrx.rb"
end
if defined?(WIN32OLE) and test(?e, "rrxwin.rb")
  src << "rrxwin.rb"
end
if src.size > 0
  flist = src.join(', ')
  puts "install  #{flist}"
else
  puts "can't find rrx.rb | rrxwin.rb(on MS-Windows)"
  exit
end

rcmd_path = search_rcmd_path()
dest_dir = nil
ary = $:
ary.each {|dir|
  dir = dir.gsub(/\\/, "/")
  if dir =~ /site_ruby\/\d[^\/]+$/
    dest_dir = dir
    break
  end
}
if dest_dir
  ary = ["rrx.rb", "rrx.cfg", "rrxwin.rb", "rrxwin.cfg"]
  remove_old_file(*ary)
  src.each {|src_name|
    FileUtils.cp(src_name, dest_dir, {:preserve=>true})
    puts "copy '#{src_name}' to '#{dest_dir}'"
  }
  if rcmd_path
    puts "'Rcmd.exe' path: '#{rcmd_path}'"
  elsif defined?(WIN32OLE)
    puts "can't find 'Rcmd.exe'"
  end
else
  puts "can't copy 'rrx.rb' | 'rrxwin.rb'(on MS-Windows)"
end
