#!/usr/local/bin/ruby -Ku
  # １つのcsvファイルから複数の行列を切り取って処理  (coding: utf-8)
require "rrx"
    # Rプログラムの定義
rpro = <<EOS
dtf <- read.csv("@@last@@", header=T, row.names=1)
dtf
xx <- chisq.test(dtf)
xx
EOS
    # 行列を一つづつ取り出して処理
count = 0
Rrx.cut_table("data02.csv") do |tbl|
  count += 1
  Rrx.temp_make(tbl)  # csvデータの一時ファイルを作成
  logname = sprintf("log%02d.txt", count)
  hs = Rrx.rexec(rpro, logname)
  next  unless hs[:sink]
  regex = /^\w\S* = (.+?), df = (.+?), p-value [<>=]+ (.+)$/
  chi,df,pval = regex =~ hs[:sink] ? [$1.to_f, $2.to_i, $3.to_f] : [nil]*3
  printf("検定#%d\n", count)
  printf("χ2 %g, df %d, p-value %g\n\n", chi, df, pval)
end
