#!/usr/local/bin/ruby -Ku
  # カイ２乗検定の結果とクラメール係数を表示  (coding: utf-8)
require "rrx"
    # Rプログラムの定義
rpro = <<EOS
data_frame <- read.csv("@@last@@", @@$ropt@@)
mt <- as.matrix(data_frame)  # データフレームを行列に変換
xx <- chisq.test(mt)
xx$cramer <- sqrt(xx$statistic / (min(nrow(mt), ncol(mt)) - 1) / sum(mt))
robj(xx)
EOS
    # 各々の表についてRプログラムを実行
count = 0
Rrx.cut_table("data02.csv", 3) do |tbl, title, ropt|
  count += 1
  Rrx.temp_make(tbl)  # 抽出した表を一時ファイルに書き出す
  $ropt = ropt
  hs = Rrx.rexec(rpro)
  next  unless hs["robj1"]
  xx = hs["robj1"]
  printf("検定#%d(%s)\n", count, title)
  names = %w(chi df p-value cramer)
  %w(statistic parameter p.value cramer).each do |key|
    printf("\t%s\t%g\n", names.shift, xx[key])
  end
  printf("\n")
end
