#!/usr/local/bin/ruby -Ku
  # 身長と体重についてf検定＆t検定・robj利用  (coding: utf-8)
require "rrx"
include Rrx
    # Rプログラムの定義
rpro = <<EOS
dtf <- read.csv("@@last@@", header=T)
male <- subset(dtf, 性別 == "男")
female <- subset(dtf, 性別 == "女")
for (i in 1:ncol(dtf)) {
  item <- colnames(dtf)[i]
  if (item != "身長" & item != "体重")  next
  ff <- var.test(male[[item]], female[[item]])
  ff$memo <- sprintf("%sについてのf.test", item)
  robj(ff)
  flag <- (ff$p.value >= 0.05)
  tt <- t.test(male[[item]], female[[item]], var.equal=flag)
  tt$memo <- sprintf("%sについてのt.test", item)
  robj(tt)
}
EOS
    # 行列を切り出してRプログラムを実行
cut_data("data03.csv") do |data|
  temp_make(data)  # 抽出した表を一時ファイルに書き出す
  hs = rexec(rpro)
  next  unless hs["robj1"]
  n = 0
  while (xx = hs["robj#{n+=1}"]) != nil
    memo = xx.delete("memo")
    puts "** #{memo}"
    xx.each do |key, val|
      printf("\t%s\t", key)
      p val
    end
    printf("\n")
  end
end
